<?php
namespace nur\sery\db;

/**
 * Class ITransactor: un objet qui peut faire des opérations dans une
 * transaction
 */
interface ITransactor {
  /**
   * Indiquer qu'une transaction va être étendue à tous les objets mentionnés
   */
  function willUpdate(...$transactors): self;

  function inTransaction(): bool;

  /** si $func!==null, la lancer puis commiter la transaction */
  function beginTransaction(?callable $func=null): void;

  function commit(): void;

  function rollback(): void;
}
